unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, ComCtrls, Buttons, opcGroupdlg,
  opcda,dOPCBrowseDlg,inifiles,
  ImgList, dOPC;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    TreeView1: TTreeView;
    ItemView: TListView;
    Panel3: TPanel;
    Label12: TLabel;
    Label14: TLabel;
    LServer: TLabel;
    Label16: TLabel;
    LStartTime: TLabel;
    Label17: TLabel;
    LState: TLabel;
    Label18: TLabel;
    LInfo: TLabel;
    Label13: TLabel;
    LUpdateTime: TLabel;
    Panel4: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    LName: TLabel;
    Label9: TLabel;
    LUpdate: TLabel;
    Label10: TLabel;
    LDeadBand: TLabel;
    Label11: TLabel;
    LActive: TLabel;
    Splitter1: TSplitter;
    TopPanel: TPanel;
    Label2: TLabel;
    ServerCombo: TComboBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    GroupPopup: TPopupMenu;
    AddGroup1: TMenuItem;
    RemoveGroup1: TMenuItem;
    Properties1: TMenuItem;
    ItemPopup: TPopupMenu;
    A1: TMenuItem;
    RemoveItem1: TMenuItem;
    Timer1: TTimer;
    lErrorinfo: TLabel;
    bRemoteConnect: TSpeedButton;
    BDisconnect: TSpeedButton;
    bConnect: TSpeedButton;
    ImageList1: TImageList;
    Active1: TMenuItem;
    RemoveallItems1: TMenuItem;
    RemoveallGroups1: TMenuItem;
    OPCServer: TdOPCServer;
    procedure ServerComboDropDown(Sender: TObject);
    procedure bConnectClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure bDisconnectClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure bRemoteConnectClick(Sender: TObject);
    procedure OPCServerServerShutdown(Sender: TObject; Reason: String);
    procedure OPCServerError(Sender: TObject; Errorstring: String;
      var RaiseException: Boolean);
    procedure AddGroup1Click(Sender: TObject);
    procedure RemoveGroup1Click(Sender: TObject);
    procedure Properties1Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure ItemPopupPopup(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Active1Click(Sender: TObject);
    procedure RemoveItem1Click(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure RemoveallGroups1Click(Sender: TObject);
    procedure RemoveallItems1Click(Sender: TObject);
    procedure OPCServerDatachange(Sender: TObject;
      ItemList: TdOPCItemList);
  private
    IniFile : TIniFile;
    procedure ClearInfoLabel;
    function GetSelectedGroup: tdOPCGroup;
    procedure Connect(ComputerName: string);
    procedure AddNewItems(ItemIds: TStringList);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure UpdateListViewItem(ListItem: TListItem; OPCItem: TdOPCItem);
begin
  ListItem.SubItems[2] := OPCItem.ValueStr;   // Value as string;
  ListItem.SubItems[3] := TimeToStr(OPCItem.TimeStamp); // TimeStamp
  if OPCItem.Quality = OPC_QUALITY_GOOD then
    ListItem.SubItems[4] := 'good'                      // Quality
  else
    ListItem.SubItems[4] := 'bad';                      // Quality
end;


procedure ShowListViewItem(ListItem: TListItem; OPCItem: TdOPCItem);
begin
  ListItem.SubItems.Clear;
  ListItem.Caption := OPCItem.ItemId;
  ListItem.SubItems.Add(OPCItem.AccessPath);
  if OPCItem.IsActive then
   ListItem.SubItems.Add('X')
  else
   ListItem.SubItems.Add(' ');
  ListItem.SubItems.Add('-');   // Value
  ListItem.SubItems.Add('-');   // TimeStamp
  ListItem.SubItems.Add('-');   // Quality
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  IniFile.free;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ServerCombo.Text := IniFile.ReadString('SERVER','LAST','');
  ClearInfoLabel;
  lErrorInfo.Caption   := '';
end;


procedure TForm1.ServerComboDropDown(Sender: TObject);
begin
  if trim(ServerCombo.Items.Text) = '' then  // if no OPC Servernames loaded
  begin
    Screen.Cursor := crHourGlass;
    GetOPCServers(ServerCombo.Items);        // get Servernames from registry
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.Connect(ComputerName: string);
begin
   OpcServer.Computername   := ComputerName;
   lErrorInfo.Caption       := '';
   OpcServer.ServerName     := ServerCombo.Text;   // set Servername from Combobox
   OpcServer.Active         := true;               // connect to Server
   Timer1.Enabled           := true;
   IniFile.WriteString('SERVER','LAST',OpcServer.ServerName);
end;

procedure TForm1.bRemoteConnectClick(Sender: TObject);
var
  CName : string;
begin
   CName := '';
   if InputQuery('Select remote Computer','Computername',CName) then
     Connect(CName);
end;

procedure TForm1.bConnectClick(Sender: TObject);
begin
   Connect('');
end;

procedure TForm1.bDisconnectClick(Sender: TObject);
begin
  OpcServer.Active := false;
end;

procedure TForm1.ClearInfoLabel;
var
  i : integer;
  C : TComponent;
begin
  for i := 0 to ComponentCount-1 do        // clears all Infolabels
  begin
    C := Components[i];
    if (C.Tag = 1) and (C is TLabel) then
      TLabel(C).Caption := '';
  end;
  LServer.Caption := 'not connected';
end;

function TForm1.GetSelectedGroup: tdOPCGroup;
var
  Node : TTreeNode;
begin
  result := nil;
  Node := TreeView1.Selected;
  if Node <> nil then
    result := OPCServer.OPCGroups.GetOPCGroup(Node.Text); // get Group
end;



procedure TForm1.Timer1Timer(Sender: TObject);
var
  Group: tdOPCGroup;
  State: TGroupStateRec;
  ServerState : TServerStateRec;
begin
  Timer1.Enabled := false;        // no timer event
  if OPCServer.Active then
  begin
    try
      Group := GetSelectedGroup;  // selected Group from Treeview
      if Group <> nil then
      begin
         Group.GetState(State); // get state direct from OPC Server
         LName.Caption     := State.Name;
         LUpdate.Caption   := IntToStr(State.UpdateRate);
         LDeadBand.Caption := format('%.2f',[State.DeadBand]);
         if State.IsActive then
           LActive.Caption := 'active'
         else
           LActive.Caption := 'not active';
      end
      else ClearInfoLabel;
      ServerState         := OpcServer.GetState;
      LServer.Caption     := OpcServer.Servername;
      LState.Caption      := ServerstatetoStr(ServerState.ServerState);
      LInfo.Caption       := ServerState.VendorInfo;
      LStartTime.Caption  := DateTimetoStr(ServerState.StartTime);
      LUpdateTime.Caption := DateTimetoStr(ServerState.LastUpdateTime);
      Timer1.Enabled := true;
    except
      Timer1.Enabled   := false;   // no Timer Event
      OPCServer.Active := false;   // if error then disconnect from OPC Server
      ClearInfoLabel;              // Clear infolabels
    end;
  end
  else
    ClearInfoLabel;
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
  close;
end;



procedure TForm1.OPCServerServerShutdown(Sender: TObject; Reason: String);
begin
  Timer1.Enabled := false;   // no timer
  ClearInfoLabel;            // clear Infolables
  lErrorInfo.Caption :='Disconnect from Server';
end;

procedure TForm1.OPCServerError(Sender: TObject; Errorstring: String;
  var RaiseException: Boolean);
begin
  lErrorInfo.Caption := ErrorString;

end;

procedure TForm1.AddGroup1Click(Sender: TObject);
var
  GroupParams : tGroupStateRec;
  Node : TTreeNode;
begin
  fillchar(GroupParams,sizeof(GroupParams),0);
  GroupParams.UpdateRate := OPCServer.OPCGroupDefault.UpdateRate;
  GroupParams.IsActive   := OPCServer.OPCGroupDefault.IsActive;
  GroupParams.LocaleId   := OPCServer.OPCGroupDefault.LocaleId;
  GroupParams.DeadBand   := OPCServer.OPCGroupDefault.DeadBand;
  GroupParams.TimeBias   := OPCServer.OPCGroupDefault.TimeBias;
  if OPCEditGroupDialog(GroupParams) then
  begin
    OPCServer.OPCGroupDefault.UpdateRate := GroupParams.UpdateRate;
    OPCServer.OPCGroupDefault.IsActive   := GroupParams.IsActive;
    OPCServer.OPCGroupDefault.LocaleId   := GroupParams.LocaleId;
    OPCServer.OPCGroupDefault.DeadBand   := GroupParams.DeadBand;
    OPCServer.OPCGroupDefault.TimeBias   := GroupParams.TimeBias ;
    OPCServer.OPCGroups.Add(GroupParams.Name);      // add to  OPC Server
    Node := TreeView1.Items.AddChild(nil,GroupParams.Name); // add to Tree
    Node.Selected := true;
    Node.Focused  := true;
  end;
end;

procedure TForm1.RemoveGroup1Click(Sender: TObject);
var
  Node : TTreeNode;
begin
  Node := TreeView1.Selected;
  if Node <> nil then
  begin
    OPCServer.OPCGroups.Remove(Node.Text);  // delete from Server
    ItemView.Items.Clear;
    Treeview1.Items.Delete(Node);           // delete from Tree
  end;
end;


procedure TForm1.RemoveallGroups1Click(Sender: TObject);
begin
  OPCServer.OPCGroups.RemoveAll;  // delete from Server
  ItemView.Items.Clear;
  Treeview1.Items.Clear;                // delete from Server
end;


procedure TForm1.Properties1Click(Sender: TObject);
var
  Group : TdOPCGroup;
  Node : TTreeNode;
  GroupParams : tGroupStateRec;
begin
  Node := TreeView1.Selected;
  if Node <> nil then
  begin
    Group := OPCServer.OPCGroups.GetOPCGroup(Node.Text); // get Group
    if Group <> nil then
    begin
      GroupParams.Name       := Group.Name;
      GroupParams.UpdateRate := Group.UpdateRate;
      GroupParams.IsActive   := Group.IsActive;
      GroupParams.LocaleId   := Group.LocaleId;
      GroupParams.DeadBand   := Group.DeadBand;
      GroupParams.TimeBias   := Group.TimeBias;
      if OPCEditGroupDialog(GroupParams) then
      begin
        Group.Name       := GroupParams.Name;
        Node.Text        := GroupParams.Name;
        Group.UpdateRate := GroupParams.UpdateRate;
        Group.IsActive   := GroupParams.IsActive;
        Group.LocaleId   := GroupParams.LocaleId;
        Group.DeadBand   := GroupParams.DeadBand;
        Group.TimeBias   := GroupParams.TimeBias;
      end;
    end
    else ShowMessage('ERROR');
  end
  else ShowMessage('First select Group');
end;


procedure TForm1.AddNewItems(ItemIds: TStringList);
var
  Item    : TListItem;
  Group   : tdOPCGroup;
  OPCItem : tdOpcItem;
  i       : integer;
begin
  Group := GetSelectedGroup;
  if Group <> nil then
  begin
    for i := 0 to ItemIds.Count-1 do
    begin
      Group.DefaultItem.IsActive := true;
      OPCItem := Group.OPCItems.AddItem(ItemIds[i]); // add new Item
      Item := ItemView.Items.Add;                    // add new viewitem
      OPCItem.Data := Item;                          // set pointer to view
      Item.Data := OPCItem;                          // set pointer to OpcItem
      Item.Caption := OPCItem.ItemId;
      ShowListViewItem(Item,OPCItem);
    end;
  end;
end;

procedure TForm1.A1Click(Sender: TObject);
var
  ItemIds: TStringlist;
begin
    ItemIds := TStringlist.create;
    try
       if OPCBrowseDialog(OPCServer.Browser, ItemIds) then
       begin
         AddNewItems(ItemIds);
       end
    finally
      ItemIds.Free;
    end;
end;

procedure TForm1.ItemPopupPopup(Sender: TObject);
var
 Enable : boolean;
 i      : integer;
 ListItem : TListItem;
begin
  Enable :=  GetSelectedGroup <> nil;         // only Enable if group selected
  for i := 0 to ItemPopup.Items.Count -1 do
     ItemPopup.Items[i].Enabled := Enable;
  if Enable then
  begin
     ListItem := ItemView.Selected;
     if ListItem <> nil then
     begin
       Active1.Checked := tdOPCItem(ListItem.Data).IsActive;
     end;
  end;
end;

procedure TForm1.OPCServerDatachange(Sender: TObject; ItemList: TdOPCItemList);
var
  ListItem : TListItem;
  OPCItem  : tdOpcItem;
  i        : integer;
begin
  for i := 0 to ItemList.Count-1 do
  begin
     OPCItem  := ItemList[i];
     ListItem := OPCItem.Data;
     if ListItem <> nil then
       UpdateListViewItem(ListItem, OPCItem);
  end;
end;



procedure TForm1.Active1Click(Sender: TObject);
var
  ListItem : TListItem;
begin
  ListItem := ItemView.Selected;
  if ListItem <> nil then
  begin
    tdOPCItem(ListItem.Data).IsActive := not Active1.Checked;
    ShowListViewItem(ListItem,tdOPCItem(ListItem.Data));
    UpdateListViewItem(ListItem,tdOPCItem(ListItem.Data));
  end;
end;

procedure TForm1.RemoveItem1Click(Sender: TObject);
var
  ListItem : TListItem;
begin
  ListItem := ItemView.Selected;
  if ListItem <> nil then
  begin
    tdOPCItem(ListItem.Data).Free;
    ListItem.Free;
  end;
end;



procedure TForm1.TreeView1Change(Sender: TObject; Node: TTreeNode);
var
  ListItem : TListItem;
  OPCItem  : TdOpcItem;
  Group    : tdOPCGroup;
  i        : integer;
begin
  Group := GetSelectedGroup;

  for i := 0 to Itemview.Items.Count-1 do       // we want to clear Listview
  begin                                         // so we have to clear pointer
     ListItem := Itemview.Items[i];             // on OPCItems
     tdOPCItem(ListItem.Data).Data := nil;
  end;
  Itemview.Items.Clear;                         // Clear Items in Listview

  if Group = nil then exit;

  for i := 0 to Group.OPCItems.Count-1 do       // now get the new Items
  begin
    OPCItem  := Group.OPCItems[i];
    ListItem := ItemView.Items.Add;             // add new viewitem
    OPCItem.Data     := ListItem;               // set pointer to view
    ListItem.Data    := OPCItem;                // set pointer to OpcItem
    ShowListViewItem(ListItem,OPCItem);
    UpdateListViewItem(ListItem,OPCItem);
  end;
end;

procedure TForm1.RemoveallItems1Click(Sender: TObject);
var
  Group    : tdOPCGroup;
begin
  Group := GetSelectedGroup;
  if Group <> nil then
  begin
     Group.OPCItems.RemoveAll;
     ItemView.Items.Clear;
  end;
end;

end.
